=== debian/changelog ===
fluidsynth (2.1.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Import patch that fixes use-after-free vulnerability. (CVE-2021-28421)
    (Closes: #987168)

 -- Reiner Herrmann <reiner@reiner-h.de>  Sat, 24 Apr 2021 13:37:51 +0200

fluidsynth (2.1.7-1) unstable; urgency=medium

  * New upstream version 2.1.7
  * d/copyright: Update authors for 'Files: *' and years
  * d/copyright: Fix mutated vowels
  * d/upstream/metadata: Remove name and add archive

 -- Dennis Braun <d_braun@kabelmail.de>  Tue, 09 Feb 2021 21:43:23 +0100
