=== src/CMakeLists.txt ===
--- 
+++ 
@@ -83,6 +83,10 @@
 if ( DSOUND_SUPPORT )
   set ( fluid_dsound_SOURCES drivers/fluid_dsound.c )
 endif ( DSOUND_SUPPORT )
+
+if ( WASAPI_SUPPORT )
+  set ( fluid_wasapi_SOURCES drivers/fluid_wasapi.c )
+endif ( WASAPI_SUPPORT )
 
 if ( WAVEOUT_SUPPORT )
   set ( fluid_waveout_SOURCES drivers/fluid_waveout.c )
@@ -204,7 +208,9 @@
     midi/fluid_midi_router.c
     midi/fluid_midi_router.h
     midi/fluid_seqbind.c
+    midi/fluid_seqbind_notes.cpp
     midi/fluid_seq.c
+    midi/fluid_seq_queue.cpp
     drivers/fluid_adriver.c
     drivers/fluid_adriver.h
     drivers/fluid_mdriver.c
@@ -279,6 +285,7 @@
     ${fluid_portaudio_SOURCES}
     ${fluid_pulse_SOURCES}
     ${fluid_dsound_SOURCES}
+    ${fluid_wasapi_SOURCES}
     ${fluid_waveout_SOURCES}
     ${fluid_winmidi_SOURCES}
     ${fluid_sdl2_SOURCES}
@@ -368,9 +375,16 @@
 
 set ( fluidsynth_SOURCES fluidsynth.c )
 
+if ( WASAPI_SUPPORT )
+  set ( fluidsynth_SOURCES ${fluidsynth_SOURCES} fluid_wasapi_device_enumerate.c )
+endif ( WASAPI_SUPPORT )
+
 add_executable ( fluidsynth
     ${fluidsynth_SOURCES}
 )
+
+set_target_properties ( fluidsynth
+    PROPERTIES IMPORT_PREFIX "" )
 
 if ( FLUID_CPPFLAGS )
   set_target_properties ( fluidsynth
@@ -396,14 +410,3 @@
     ARCHIVE DESTINATION ${LIB_INSTALL_DIR}
     PUBLIC_HEADER DESTINATION ${INCLUDE_INSTALL_DIR}/fluidsynth 
 )
-   install ( FILES ${public_main_HEADER} DESTINATION ${INCLUDE_INSTALL_DIR} )
-endif ( MACOSX_FRAMEWORK )
-
-# ******* Auto Generated Lookup Tables ******
-
-include(ExternalProject)
-
-set (GENTAB_SDIR ${CMAKE_CURRENT_SOURCE_DIR}/gentables)
-set (GENTAB_BDIR ${CMAKE_CURRENT_BINARY_DIR}/gentables)
-
-# Use external project to ensure that cmake uses the host compiler when building make_tables.exe
