=== debian/changelog ===
fluidsynth (2.2.3-2~mx21+1) mx; urgency=medium

  * Initial packaging of upstream release for MX-21.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Mon, 22 Nov 2021 12:39:44 -0500

fluidsynth (2.2.3-2) unstable; urgency=medium

  * Upload to unstable

 -- Dennis Braun <d_braun@kabelmail.de>  Sun, 21 Nov 2021 18:13:22 +0100

fluidsynth (2.2.3-1) experimental; urgency=medium

  [ Dennis Braun ]
  * New upstream version 2.2.3
  * Bump Standards-Version to 4.6.0
  * Bump soname libfluidsynth2 to libfluidsynth3
  * d/copyright: Update entry for doc/examples
  * d/copyright: Add myself to the d/ section
  * Update examples installation
  * d/rules: override_dh_auto_test because the tests fail
  * Update symbols file

  [ Sebastian Ramacher ]
  * debian/libfluidsynth3.symbols:
    - Remove dropped symbol
    - Mark template instantiations as optional
  * debian/rules:
    - Use /usr/share/dpkg/architecture.mk
    - Remove unnecessary argument to dh

 -- Dennis Braun <d_braun@kabelmail.de>  Sat, 23 Oct 2021 19:02:57 +0200
