=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: fluidsynth
 Section: sound
 Priority: optional
-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Alessio Treglia <alessio@debian.org>,
  David Henningsson <diwic@ubuntu.com>,
@@ -22,7 +23,7 @@
  libsndfile-dev,
  libsystemd-dev [linux-any],
  libtool,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/Fluidsynth/fluidsynth
 Vcs-Git: https://salsa.debian.org/multimedia-team/fluidsynth.git
 Vcs-Browser: https://salsa.debian.org/multimedia-team/fluidsynth
@@ -47,7 +48,7 @@
  The MIDI events are read from a MIDI device. The sound is rendered in
  real-time to the sound output device.
 
-Package: libfluidsynth2
+Package: libfluidsynth3
 Architecture: any
 Multi-Arch: same
 Pre-Depends:
@@ -75,7 +76,7 @@
 Multi-Arch: same
 Section: libdevel
 Depends:
- libfluidsynth2 (= ${binary:Version}),
+ libfluidsynth3 (= ${binary:Version}),
  ${misc:Depends},
 Description: Real-time MIDI software synthesizer (development files)
  Fluidsynth is a real-time midi synthesizer based on the soundfont (sf2 and sf3)
