=== debian/rules ===
--- 
+++ 
@@ -1,14 +1,18 @@
 #!/usr/bin/make -f
+
+include /usr/share/dpkg/architecture.mk
 
 ifneq ($(findstring $(DEB_HOST_ARCH_OS),kfreebsd hurd),)
 EXTRA_CONFIGURE_ARGS += -Denable-alsa=off -Denable-dbus=off
 endif
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ -Scmake --without autoreconf
+	dh $@
+
+override_dh_strip:
+	dh_strip --no-automatic-dbgsym
 
 override_dh_auto_configure:
 	dh_auto_configure -- \
@@ -25,3 +29,5 @@
 	   debian/fluidsynth/etc/default/fluidsynth
 	sed -e '/SOUND_FONT/s/#//' \
 	    -i debian/fluidsynth/etc/default/fluidsynth
+
+override_dh_auto_test:
